-------------------------------------------------------------------------------
------------------------------ SCRIPT SETUP -----------------------------------
-------------------------------------------------------------------------------

local advice = require "export_advice"
local historic_events = require "export_historic_events"
local scripting = require "EpisodicScripting"
local camera_pan = 0
local new_game = false

scripting.SetCampaign("mp_eur_napoleon")
out.ting("MP Europe Script!")


local function OnNewCampaignStarted(context)
	new_game = true
end



local function OnUICreated(context)
	-- Re-enabling the generic campaign won message
	scripting.OverrideMessageAutoShow("campaign_won", true)
end

	
-------------------------------------------------------------------------------------------------------------------------
--
-- TRIGGERS THE INITIAL TURN CAMERA PANS, TIED INTO ADVICE
--

local function OnAdviceIssued(context)
	
	-- 1009a_Campaign_Advice_Austria_Initial_Turns_Thread
	if conditions.AdviceJustDisplayed("773515340", context) and not CampaignUI.IsMultiplayer() then
		scripting.game_interface:steal_user_input(true)
		scripting.game_interface:show_shroud(false)
		scripting.game_interface:set_zoom_limit(1.00, 0.2)
		CampaignUI.ScrollCamera(30,	
								{-25.000, -21.000, 0.9},
								{-177.000, -81.000, 0.8},
								{-258.000, -3.000, 0.7},
								{-93.000, -19.000, 0.8})
		camera_pan = 10

		
	-- 1001a_Campaign_Advice_Britain_Initial_Turns_Thread
	elseif conditions.AdviceJustDisplayed("-1065946002", context) and not CampaignUI.IsMultiplayer() then
		scripting.game_interface:steal_user_input(true)
		scripting.game_interface:show_shroud(false)
		scripting.game_interface:set_zoom_limit(1.00, 0.2)
		CampaignUI.ScrollCamera(33,	
								{-242.000, 36.000, 0.9},
								{-210.000, -0.000, 0.7},
								{-114.000, -56.000, 0.75},
								{-26.000, -25.000, 0.8},
								{-91.000, 12.000, 0.65},
								{-153.000, -2.000, 0.95})
		camera_pan = 20

		
	-- 1005a_Campaign_Advice_Russia_Initial_Turns_Thread
	elseif conditions.AdviceJustDisplayed("704891735", context) and not CampaignUI.IsMultiplayer() then
		scripting.game_interface:steal_user_input(true)
		scripting.game_interface:show_shroud(false)
		scripting.game_interface:set_zoom_limit(1.00, 0.2)
		CampaignUI.ScrollCamera(28,	
								{260.000, 83.000, 0.95},
								{-27.000, -60.000, 0.5},
								{-107.000, -18.000, 0.75})
		camera_pan = 30
		

	-- 1006a_Campaign_Advice_Prussia_Initial_Turns_Thread
	elseif conditions.AdviceJustDisplayed("1248357663", context) and not CampaignUI.IsMultiplayer() then
		scripting.game_interface:steal_user_input(true)
		scripting.game_interface:show_shroud(false)
		scripting.game_interface:set_zoom_limit(1.00, 0.2)
		CampaignUI.ScrollCamera(49,	
								{-68.000, 46.000, 0.9},
								{-200.000, 0.000, 0.7},
								{-120.000, -40.000, 0.6},
								{-25.000,-26.000, 0.7},
								{-106.000, -24.000, 0.7})
		camera_pan = 40
		
	end
end


local function OnCameraMoverFinished(context)

	-- 1009a_Campaign_Advice_Austria_Initial_Turns_Thread
	if camera_pan == 10 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(2,	
								{-93.000, -19.000, 0.8},
								{-93.000, -19.000, 0.801})
		camera_pan = 11

	elseif camera_pan == 11 then	
		CampaignUI.ScrollCamera(27,	
								{120.000, 10.000, 0.9},
								{30.000, 63.000, 0.7},
								{-20.000, 24.000, 0.85},
								{-25.000, -21.000, 0.9})
		camera_pan = 12
		
	elseif camera_pan == 12 then	
		scripting.game_interface:show_shroud(true)
		scripting.game_interface:steal_user_input(false)
		scripting.game_interface:set_zoom_limit(1.0, 0.61)
		CampaignUI.SetCameraZoom(0.85)
		CampaignUI.SetCameraTargetInstant(-25.000, -21.000)
		camera_pan = 0
		scripting.game_interface:add_time_trigger("trigger_austria_research", 0.25)

				
	-- 1001a_Campaign_Advice_Britain_Initial_Turns_Thread
	elseif camera_pan == 20 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(2,	
								{-153.000, -2.000, 0.95},
								{-153.000, -2.000, 0.951})
		camera_pan = 21
	
	elseif camera_pan == 21 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(18,	
								{-153.000, -2.000, 0.951},
								{-250.000, 0.000, 0.7},
								{-367.000, -154.000, 0.95})
								
		camera_pan = 22
		
	elseif camera_pan == 22 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(4,
								{-367.000, -154.000, 0.95},
								{-367.000, -154.000, 0.951})
								
		camera_pan = 23
		
	elseif camera_pan == 23 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(11,
								{-367.000, -154.000, 0.951},
								{-239.000, -85.000, 0.7},
								{-239.000, 30.000, 0.95})
		camera_pan = 24		

		
	elseif camera_pan == 24 then
		scripting.game_interface:show_shroud(true)
		scripting.game_interface:steal_user_input(false)
		scripting.game_interface:set_zoom_limit(1.0, 0.61)
		CampaignUI.SetCameraZoom(0.85)
		CampaignUI.SetCameraTargetInstant(-239.000, 30.000)
		camera_pan = 0
		
	
	-- 1005a_Campaign_Advice_Russia_Initial_Turns_Thread
	elseif camera_pan == 30 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(3,
								{-107.000, -18.000, 0.75},
								{-107.000, -18.000, 0.751})
		camera_pan = 31		

	elseif camera_pan == 31 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(19,
								{-107.000, -18.000, 0.751},
								{32.000, 32.000, 0.9},
								{256.000, 83.000, 0.7})
		camera_pan = 32
		
	elseif camera_pan == 32 then
		scripting.game_interface:show_shroud(true)
		scripting.game_interface:steal_user_input(false)
		scripting.game_interface:set_zoom_limit(1.0, 0.61)
		CampaignUI.SetCameraZoom(0.7)
		CampaignUI.SetCameraTargetInstant(256.000, 83.000)
		camera_pan = 0
		scripting.game_interface:add_time_trigger("trigger_russia_prussia", 0.25)
	
		
	-- 1006a_Campaign_Advice_Prussia_Initial_Turns_Thread
	elseif camera_pan == 40 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(5,	
								{-106.000, -24.000, 0.7},
								{-106.000, -24.000, 0.701})
		camera_pan = 41
	
	elseif camera_pan == 41 then
		scripting.game_interface:set_zoom_limit(1.0, 0.5)
		CampaignUI.ScrollCamera(18,	
								{129.000, 77.000, 0.9},
								{32.000, 33.000, 0.7},
								{-70.000, 46.000, 0.9})
		camera_pan = 42
	
	elseif camera_pan == 42 then
		scripting.game_interface:show_shroud(true)
		scripting.game_interface:steal_user_input(false)
		scripting.game_interface:set_zoom_limit(1.0, 0.61)
		CampaignUI.SetCameraZoom(0.85)
		CampaignUI.SetCameraTargetInstant(-70.000, 46.000)
		camera_pan = 0
		scripting.game_interface:add_time_trigger("trigger_prussia_build_military", 0.25)
	
	end
end


-------------------------------------------------------------------------------------------------------------------------
--
-- SET UP THE ESCAPE KEY TO CIRCUMVENT PLAYER INTERACTION LOCKING
--

function OnKeyPressed(key, is_key_up)
	if is_key_up == true then
		if key == "ESCAPE" then
			local local_current_advice = current_advice
			if camera_pan ~= "" then
				CampaignUI.StopCamera()
			end
			if local_current_advice ~= "" and local_current_advice == current_advice then
				CampaignUI.DismissAdvice()
			end
		end
	end
end
	
--------------------------------------------------------------------------------------------------------------------
-- Add event callbacks
-- For a list of all events supported create a "documentation" directory in your empire directory, run a debug build of the game and see
-- the events.txt file
--------------------------------------------------------------------------------------------------------------------


scripting.AddEventCallBack("FactionTurnStart", OnFactionTurnStart)
scripting.AddEventCallBack("AdviceIssued", OnAdviceIssued)
scripting.AddEventCallBack("AdviceDismissed", OnAdviceDismissed)
scripting.AddEventCallBack("CameraMoverCancelled", OnCameraMoverCancelled)
scripting.AddEventCallBack("CameraMoverFinished", OnCameraMoverFinished)
scripting.AddEventCallBack("UICreated", OnUICreated)
scripting.AddEventCallBack("TimeTrigger", OnTimeTrigger)
scripting.AddEventCallBack("SavingGame", OnSavingGame)
scripting.AddEventCallBack("LoadingGame", OnLoadingGame)
scripting.AddEventCallBack("MissionSucceeded", OnMissionSucceeded)
scripting.AddEventCallBack("BattleCompleted", OnBattleCompleted)
scripting.AddEventCallBack("NewCampaignStarted", OnNewCampaignStarted)
scripting.AddEventCallBack("SettlementOccupied", OnSettlementOccupied)